/// <reference types="svelte" />
import type { Readable, StartStopNotifier, Writable } from "svelte/store";
export declare const Refuse: unique symbol;
export type Refuse = typeof Refuse;
export declare class Accessor<P, C> {
    readonly readChild: (parent: P) => C | Refuse;
    readonly writeChild: (parent: P, newChild: C) => void;
    constructor(readChild: (parent: P) => C | Refuse, writeChild: (parent: P, newChild: C) => void);
    and<GC>(other: Accessor<C, GC>): Accessor<P, GC>;
}
export declare function into<P, K extends keyof P>(key: K): Accessor<P, P[K]>;
export declare function intoMap<K extends string | number | symbol, V>(key: K): Accessor<Map<K, V>, V>;
export declare function isPresent<P>(parent: P): NonNullable<P> | Refuse;
export type StoreTreeCore<P> = {
    zoom<C>(accessor: Accessor<P, C>): WritableTree<C>;
    zoomNoSet<C>(readChild: (parent: P) => C | Refuse): ReadableTree<C>;
    choose<P_ extends P>(readChild: (parent: P) => P_ | Refuse): WritableTree<P_>;
};
export type ReadableTree<P> = Readable<P> & StoreTreeCore<P>;
export type WritableTree<P> = Writable<P> & StoreTreeCore<P>;
export declare function readableTree<P>(value: P, start?: StartStopNotifier<P>): ReadableTree<P>;
export declare function writableTree<P>(value: P, start?: StartStopNotifier<P>): WritableTree<P>;
